QGIS Application - Bug report #16798
Virtual layers don't work correctly with FilterFid feature requests
2017-07-06 12:59 AM - Nyall Dawson

Status: Closed

Priority: Normal

Assignee: Hugo Mercier

Category: Virtual Layers

Affected QGIS version:2.18.10 Regression?: No
Operating System: Easy fix?: No
Pull Request or Patch supplied: Resolution:

Crashes QGIS or corrupls data: Copied to github as #: 24697
Description

Not sure if this is a regression or something which was never supported, but virtual layers always return the same feature when attempting
to fetch a particular feature with a filterfid request.

Steps to reproduce:

1. load two layers

2. create a virtual layer using a cross join type "select * from layerA, layerB"

3. Try fetching features using a non restricted request, eg:
ids = [f.id() for f in layer.getFeatures()]

this works OK

4. Try fetching a specific feature:
f.getFeatures(QgsFeatureRequest.setFilterFid(ids[4])).next()

Regardless of the feature id requested, only the first feature in the table is returned.

This may be due to the query not having a unique key field - but if that's the case it becomes impossible to create cross join type virtual
layers (since sqllite doesn't have a row_number() type function which could be used to create fake unique ids in the query).

This breaks various QGIS functionality with the resultant layer - e.g. it can't be used with atlas. Possibly #15709 is related too.

Associated revisions

Revision d0d88e44 - 2017-11-15 01:09 PM - Paul Blottiere

Fixes #16798 FilterFid feature requests with virtual layers

Revision 9f0985ff - 2017-11-15 05:20 PM - Paul Blottiere

Merge pull request #5554 from pblottiere/bugfix_virtuallayer

[budfix] Fixes #16798 FilterFid feature requests with virtual layers

Revision 577c1f2e - 2017-11-22 02:46 PM - Paul Blottiere

Fixes #16798 FilterFid feature requests with virtual layers
Revision 485cd80a - 2017-11-27 09:14 AM - Paul Blottiere

Merge pull request #5695 from pblottiere/bugfix_virtuallayer_218

[backport][bugfix] Fixes #16798 FilterFid feature requests with virtual layers

History

#1 - 2017-08-30 10:19 PM - Nyall Dawson

This also affects copying from virtual layers

#2 - 2017-09-22 09:53 AM - Jiirgen Fischer

- Category set to Unknown

#3 - 2017-09-22 11:24 AM - Jiirgen Fischer
- Category changed from Unknown to Virtual Layers

#4 - 2017-11-15 05:20 PM - Paul Blottiere
- % Done changed from 0 to 100
- Status changed from Open to Closed

Applied in changeset commit:qgis|d0d88e440a7c847953b49004b6725f90276dc7e3.
